tons of misc updates
[distro-setup] / check-subvol-stale
index bdb47492ef07b132914b21ec6773014675dca38f..c585cea0169c2fb9bde14224380f252100f5067f 100644 (file)
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-# usage: $0 SUBVOL_MOUNTPOINT...
-#
-# In git, this is not not executable because it's meant to be installed
-# using ./install-my-scripts
-#
-# If latest subvols $@ are not mounted, exit 1, print message, and touch
-# /nocow/btrfs-stale/$subvol
-#
-# Either SUBVOL_MOUNTPOINT is a snapshot of the latest, or
-# the latest snapshot is snapshot of SUBVOL_MOUNTPOINT.
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
@@ -31,6 +21,41 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 shopt -s nullglob
 
+usage() {
+  cat <<EOF
+usage: $0 SUBVOL_MOUNTPOINT...
+
+In git, this is not not executable because it's meant to be installed
+using ./install-my-scripts
+
+If latest subvols \$@ are not mounted, exit 1, print message, and touch
+/nocow/btrfs-stale/\$subvol
+
+Either SUBVOL_MOUNTPOINT is a snapshot of the latest, or
+the latest snapshot is snapshot of SUBVOL_MOUNTPOINT.
+
+-d         Enable debug output
+-h|--help  Print help and exit.
+
+Note: Uses GNU getopt options parsing style
+EOF
+  exit $1
+}
+
+##### begin command line parsing ########
+
+debug=false # default
+temp=$(getopt -l help,d hd "$@") || usage 1
+eval set -- "$temp"
+while true; do
+  case $1 in
+    -d) debug=true; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
+done
+
 if [[ ! $@ ]]; then
     echo "$0: error: expected mountpoint argument"
 fi
@@ -47,12 +72,19 @@ stale-file() {
     fi
 
 }
+d() {
+  if $debug; then
+    printf "%s\n" "$*"
+    fi
+}
 
 ret=0
 for d; do
     vol=${d##*/}
     dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab|head -n1)
+    d dev=$dev
     subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab|head -n1)
+    d subvol_dir=$subvol_dir
     # note, we need $dev because $d might not be mounted, and we do this loop
     # because the device in fstab for the rootfs can be different.
     for devx in $(btrfs fi show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
@@ -60,6 +92,7 @@ for d; do
         if [[ $root_dir ]]; then break; fi
     done
     svp=$root_dir/$subvol_dir # subvolume path
+    d svp=$svp
 
     snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
     if [[ ! $snaps ]]; then
@@ -69,17 +102,19 @@ for d; do
     fi
 
     # get info on last received sub
-    last_received_gen=0
+    last_received_cgen=0
     for f in ${snaps[@]}; do
         show="$(btrfs sub show $f)"
         if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
             cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
-            if [[ $cgen -gt $last_received_gen ]]; then
+            if [[ $cgen -gt $last_received_cgen ]]; then
                 last_received_cgen=$cgen
                 last_received=$f
             fi
         fi
     done
+    d last_received_cgen=$cgen
+    d last_received=$f
 
     # Get last_snap by date.
     # when a btrbk bugfix makes it into the distro,
@@ -111,6 +146,7 @@ for d; do
     # if there is a last_received, we can assume stale or fresh if we are newer/older
     if [[ $last_received ]]; then
         svp_cgen=$(btrfs sub show $svp | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
+        d svp_cgen=$svp_cgen
         if [[ $svp_cgen -ge $last_received_cgen ]]; then
             stale=false
         else